/*
 * Licensed Materials - Property of IBM
 *
 * Copyright IBM Corporation 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA DP Schedule Contract with IBM Corp.
 */
var egl_dojoAccordionContainerCount = 1;

egl.defineWidget(
	'dojo.widgets', 'DojoAccordionContainer',
	'dojo.widgets', 'DojoContainer',
	'div',
	{
	"constructor" : function() {
		this.setChildType("dojo.widgets.DojoContentPane");
		this.selection = 1;
		this.duration = 250;
		this.width = 800;
		this.height = 450;
		dojo.require("dijit.layout.StackContainer");
		dojo.require("dijit.layout.AccordionContainer");
		dojo.require("dijit.layout.ContentPane");
		this.selection = -1;
	},
	"createDojoWidget" : function(parent) {
		this.dojoID = "egl.DojoAccordianContainer" + egl_dojoAccordionContainerCount++;
		this.dojoWidget = new dijit.layout.AccordionContainer({ 
				duration: this.duration, 
				doLayout: true, 
				id: this.dojoID,
				style: "width:"+egl.toPX(this.width)+";height:"+egl.toPX(this.height)
			}, 
			parent
		);
		this.dojoWidget.startup();
		this.addEventHandlers();
		if (this.selection != -1)
			this.setSelection(this.selection);
	},
	"addChild" : function(child, index) {
		if (child.selected)
			this.selection = index; 
		child.selected = (index == this.selection);
		egl.dojo.widgets.DojoContainer.prototype.addChild.call(this, child);
	},
	"addEventHandlers" : function() {
		var eglWidget = this;
		dojo.subscribe(this.dojoID+"-selectChild", function(child) {
			if (eglWidget.eze$$ready) {
				eglWidget.selection = eglWidget.getChildIndex(child) + 1;
				eglWidget.notifyListeners(child.eglWidget, eglWidget.getOnTabSelected(), "onTabSelected");
			}
		});
	},
	"notifyListeners" : function(widget, handlers, eventName) {
		for (var n=0; n<handlers.length; n++) {
			try {
				handlers[n]({ widget: widget});
			}
			catch (e) {
				egl.printError("DojoAccordionContainer: event handler for "+eventName+" failed.", e);
			}
		}
	},
	"getSelection" : function(){
		return this.selection;
	},
	"setSelection" : function(index){
		var eglWidget = this;
		this.selection = index;
		setTimeout(function() {
			if (eglWidget.dojoWidget) {
				var contentPanes = eglWidget.dojoWidget.getChildren();
				if (index > 0 && index <= contentPanes.length) {
					eglWidget.selection = index;
					eglWidget.dojoWidget.selectChild(contentPanes[index-1]);
				}
			}
		},1);
	},
	"getOnTabSelected" : function() { return this.onTabSelected || (this.onTabSelected = []); },
	"setOnTabSelected" : function() { throw egl.egl.ui.rui.Widget.ErrorMessageForEventHandlers; }			
});