/*
 * Licensed Materials - Property of IBM
 *
 * Copyright IBM Corporation 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA DP Schedule Contract with IBM Corp.
 */

egl.chartsToRedraw = [];

egl.defineWidget(
	'dojo.widgets', 'DojoChartBase',
	'dojo.widgets', 'DojoBase',
	'div',
{
	"constructor" : function() {
		dojo.require("dojox.fx");
		dojo.require("dojox.gfx");
		dojo.require("dojox.charting.Chart2D");
		dojo.require("dojox.charting.themes.PlotKit.blue");
		dojo.require("dojox.charting.themes.PlotKit.red");
		dojo.require("dojox.charting.themes.PlotKit.green");
		dojo.require("dojox.charting.themes.PlotKit.orange");
		dojo.require("dojox.charting.themes.PlotKit.cyan");
		dojo.require("dojox.charting.themes.PlotKit.purple");
		dojo.require("dojox.charting.action2d.Tooltip");
		dojo.require("dojox.charting.action2d.Highlight");
		dojo.require("dojox.charting.action2d.Magnify");
		dojo.require("dojox.charting.themes.MiamiNice");
	},
	"createChart" : function(parent, width, height, plot) {
		this.setWidth(this.width || width);
		this.setHeight(this.height || height);
		this.dojoWidget = new dojox.charting.Chart2D(parent);
		this.dojoWidget.addPlot("default", plot);
		if (this.themeColor) 
			this.setTheme(this.themeColor);
		if (document.documentMode == 8) {
			this.setInnerHTML("<div style='padding: 20px; height:"+(height-46)+"px; background-color: yellow; border: 3px solid red'><img src=dojo/ie8.png><p>"+
					"We're sorry.<br>In IE8, Dojo charts render only in IE7 compatibility mode.<br>"+
					"Please enable the <a target=_blank href=http:/"+"/www.microsoft.com/windows/internet-explorer/features/easier.aspx>compatibility view</a> in IE8.</div>");
		}
		if (egl.IE) {
			if (!this.addedToRedrawList) {
				egl.chartsToRedraw.push(this);
				this.addedToRedrawList = true;
			}
		}
	},
	"redraw" : function() {
		this.render();
	},
	"addAxes" : function() {
		this.dojoWidget.addAxis("y", {vertical: true} );
		this.dojoWidget.addAxis("x", {} );
	},
	"addAxesWithMinMax" : function() {
		var yAxis = {vertical: true};
		if (typeof(this.minY) !== "undefined") 
			yAxis.min = this.minY;
		if (typeof(this.maxY) !== "undefined") 
			yAxis.max = this.maxY;
		this.dojoWidget.addAxis("y", yAxis);
		var xAxis = { };
		if (typeof(this.minX) !== "undefined") 
			xAxis.min = this.minX;
		if (typeof(this.maxX) !== "undefined") 
			xAxis.max = this.maxX;
		this.dojoWidget.addAxis("x", xAxis);
	},
	"setTheme" : function(color) {
		try {
			this.dojoWidget.setTheme(dojox.charting.themes.PlotKit[color]);
		}
		catch (e) {
			this.dojoWidget.setTheme(dojox.charting.themes.PlotKit["blue"]);
		}
		new dojox.charting.action2d.Magnify(this.dojoWidget, "default", { scale: 1.1 });
		new dojox.charting.action2d.Highlight(this.dojoWidget, "default");
		new dojox.charting.action2d.Tooltip(this.dojoWidget, "default");
	}	
});