/*
 * Licensed Materials - Property of IBM
 *
 * Copyright IBM Corporation 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA DP Schedule Contract with IBM Corp.
 */

egl.defineWidget(
	'dojo.widgets', 'DojoColorPalette',
	'dojo.widgets', 'DojoBase',
	'div',
{
	"constructor" : function() {		
		var eglWidget = this;
		setTimeout(function() {
			eglWidget.renderWhenDojoIsDoneLoading();
		},1);
		dojo.require("dijit.ColorPalette");	
	},
	"createDojoWidget" : function(parent) {
		var eglWidget = this;
		this.dojoWidget = new dijit.ColorPalette({ 
				palette: this.small ? "3x4" : "7x10", 
				value: this.value,
				onChange: function() { eglWidget.handleEvent(eglWidget.getOnChange(), "onChange") }
			}, 
			parent
		);
	},
	"setValue": function(value) {
		this.value = value;
		if (this.dojoWidget)
			this.dojoWidget.setValue(value);
		else
			this.setData(value);
	},
	"getValue" : function() {
		if (this.dojoWidget)
			return this.dojoWidget.value;
		else
			return this.value;
	}
});