/*
 * Licensed Materials - Property of IBM
 *
 * Copyright IBM Corporation 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA DP Schedule Contract with IBM Corp.
 */

egl.defineWidget(
	'dojo.widgets', 'DojoComboBox',
	'dojo.widgets', 'DojoBase',
	'select',
{
	"constructor" : function() {		
		dojo.require("dijit.form.ComboBox");
		this.pageSize = -1;
	},
	"createDojoWidget" : function(parent) {
		this.runEventHandlers = function() { }; // turn off EGL basic event handlers
		var eglWidget = this;
		var args = { 
			value: this.value || "", 
			autoComplete: false,
			onChange: function() {
				eglWidget.value = eglWidget.dojoWidget.getValue();
				eglWidget.handleEvent(eglWidget.getOnChange(), "onChange"); 
				setTimeout(function() {
					eglWidget.eze$$DOMElement.getElementsByTagName("input")[0].select();
				},1);
			},
			onBlur: function() { egl.egl.ui.rui.RUILib.$inst.setTextSelectionEnabled(false); },
			onFocus: function() { 
				egl.egl.ui.rui.RUILib.$inst.setTextSelectionEnabled(true); 
				setTimeout(function() {
					eglWidget.eze$$DOMElement.getElementsByTagName("input")[0].select();
				},1);
			}
		};
		if (this.pageSize != -1)
			args.pageSize = this.pageSize;
		this.dojoWidget = new dijit.form.ComboBox(
			args, 
			parent
		);
		this.eze$$DOMElement.style.visibility = "visible";
	},
	"setValue": function(value) {
		this.value = value;
		if (this.dojoWidget)
			this.dojoWidget.setValue(value);
	},
	"getValue" : function() {
		return this.value;
	},
	"setValues": function(values) {
		this.eze$$DOMElement.style.visibility = "hidden";		
		this.values = values;
		for (var n=0; n<values.length; n++)
			egl.createChild(this.eze$$DOMElement, "option").innerHTML = values[n];
		this.setData(this.value);
	},
	"getValues" : function() {
		return this.values;
	}
});