/*
 * Licensed Materials - Property of IBM
 *
 * Copyright IBM Corporation 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA DP Schedule Contract with IBM Corp.
 */

egl.defineWidget(
	'dojo.widgets', 'DojoContentPane',
	'dojo.widgets', 'DojoContainer',
	'div',
{
	"createDojoWidget" : function(parent) {
		this.renderingStep = 4.1;
		this.assert(dijit.layout.ContentPane, "dijit.layout.ContentPane is undefined"); 
		this.dojoWidget = new dijit.layout.ContentPane({
			title: this.title, 
			refreshOnShow: true, 
			closable: this.closable, 
			selected: this.selected
		}, parent);
		this.renderingStep = 4.2;
		try {
			this.setChildren(this.children);
		}
		catch(e) {
			throw "Could not set DojoContentPane children: "+e.message;
		}
	},
	"setChildren" : function(children) {
		this.children = children;
		if (this.dojoWidget) {
			this.assert(this.dojoWidget.domNode, "dijit.layout.ContentPane has no domNode"); 
			this.renderingStep = 4.3;
			for (var n=0; n<children.length; n++)
				this.dojoWidget.domNode.appendChild(children[n].eze$$DOMElement);
			try {
				this.dojoWidget.startup();
			}
			catch (e) {
				throw "dijit.layout.ContentPane could not be started: "+e.message;
			}
		}
		else {
			this.renderWhenDojoIsDoneLoading();
		}
	},
	"appendChild" : function(child) {
		this.dojoWidget.domNode.appendChild(child.eze$$DOMElement);
	},
	"addChild" : function(child, index) {
	},
	"removeAllChildren" : function() {
		while (this.dojoWidget.domNode.firstChild)
			this.dojoWidget.domNode.removeChild(this.dojoWidget.domNode.firstChild);
	},
	"copyStyle" : function(style) {
	}
	
});