/*
 * Licensed Materials - Property of IBM
 *
 * Copyright IBM Corporation 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA DP Schedule Contract with IBM Corp.
 */

egl.currencyTextBoxCount = 1;

egl.defineWidget(
	'dojo.widgets', 'DojoCurrencyTextBox',
	'dojo.widgets', 'DojoBase',  	
	'div',									
{
	"constructor" : function() {
		dojo.require("dojo.date.locale");
		dojo.require("dijit.form.CurrencyTextBox");
	},
	"createDojoWidget" : function(parent){
		var eglWidget = this;
		this.dojoWidget = new dijit.form.CurrencyTextBox({
			id : "egl.DCTB"+egl.currencyTextBoxCount++,
			type : "text", 
			required : "true",
			value : this.data || "$0.00", 
			method : "post",
			currency : this.currency || "USD", 
			invalidMessage : this.errorMessage || "Invalid Amount", 
			onChange: function() { eglWidget.handleEvent(eglWidget.getOnChange(), "onChange") }, 
			onFocus: function() {
				eglWidget.selectionEnabled = egl.egl.ui.rui.RUILib['$inst'].getTextSelectionEnabled();
				egl.egl.ui.rui.RUILib['$inst'].setTextSelectionEnabled(true);
			}, 
			onBlur: function() { 
				egl.egl.ui.rui.RUILib['$inst'].setTextSelectionEnabled(eglWidget.selectionEnabled) 
			}
		}, parent);
		this.dojoWidget.startup();
		this.dojoWidget._onBlur();
	},
	"setValue" : function( text ) {
		if (this.dojoWidget)
			this.dojoWidget.setValue(text);
		else
			this.setData(text);
	},
	"getValue" : function() {
		if (this.dojoWidget)
			return this.dojoWidget.getValue();
	}
});