/*
 * Licensed Materials - Property of IBM
 *
 * Copyright IBM Corporation 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA DP Schedule Contract with IBM Corp.
 */

var egl_dojoDialogCount = 1;

egl.defineWidget(
	'dojo.widgets', 'DojoDialog',
	'dojo.widgets', 'DojoContainer',
	'div',
{
	"constructor" : function() {
		this.content = egl.createElement("div");
		this.content.style.display = "block";
		this.draggable = true;
		this.closeable = true;
		this.isOpen = false;
		dojo.require("dijit.Dialog");
	},
	"createDojoWidget" : function(parent) {
		this.dojoID = "egl.DojoDialog_" + egl_dojoDialogCount++;
		for (var n=0; n<this.children.length; n++) {
			this.content.appendChild(this.children[n].eze$$DOMElement);
		}
		this.dojoWidget = new dijit.Dialog({ 
			title : this.title || "", 
			draggable: this.draggable, 
			closable: this.closable,
			id: this.dojoID,
			content: this.content
		}, parent );
		this.dojoWidget.startup();
		if (this.isOpen)
			this.showDialog();
	},
	"copyStyle" : function(style) {
		for (f in style)
			try { this.content.style[f] = style[f]; } catch (e) { }
	},
	"showDialog" : function() {
		document.body.appendChild(this.eze$$DOMElement);
		this.isOpen = true;
		if (this.dojoWidget)
			this.dojoWidget.show();
		else
			this.renderWhenDojoIsDoneLoading();
	},
	"hideDialog" : function() {
		this.isOpen = false;
		if (this.dojoWidget)
			this.dojoWidget.hide();
		else
			this.renderWhenDojoIsDoneLoading();
	}
});