/*
 * Licensed Materials - Property of IBM
 *
 * Copyright IBM Corporation 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA DP Schedule Contract with IBM Corp.
 */

egl.defineWidget(
	'dojo.widgets', 'DojoMenu',
	'dojo.widgets', 'DojoContainer',
	'div',
{
	"constructor" : function() {
		this.setChildType("dojo.widgets.DojoMenuItem");
		dojo.require("dijit.Menu");
		dojo.require("dijit.form.DropDownButton");
	},
	"createDojoWidget" : function(parent){
		this.dojoMenu = new dijit.Menu();
		this.dojoMenu.startup();
		this.dojoWidget = new dijit.form.DropDownButton(
			{label: this.text||"",	dropDown: this.dojoMenu }, 
			parent
		);
		this.startup();
	},
	"startup" : function() {
		this.dojoWidget.startup();	
		var eglWidget = this;
		setTimeout(function() { 			
			eglWidget.addMenuItems();
		},1);
	},
	"destroy" : function() {
		this.dojoWidget = null;
	},
	"addMenuItems" : function() {
		try {
			for (var n=0; n<this.children.length; n++) {
				var child = this.children[n];
				if (!child.dojoWidget)
					child.render();
				this.dojoMenu.addChild(child.dojoWidget);
			}
			this.dojoMenu.startup();
		}
		catch (e) {
			egl.printError("Error in DojoMenu.addMenuItems", e);
		}
	}
});