/*
 * Licensed Materials - Property of IBM
 *
 * Copyright IBM Corporation 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA DP Schedule Contract with IBM Corp.
 */

egl.dojoRadioGroupCount = 1;

egl.defineWidget(
	'dojo.widgets', 'DojoRadioGroup',
	'dojo.widgets', 'DojoBase',
	'div',
{
	"constructor" : function() {
		this.runEventHandlers = function() { }; // turn off EGL basic event handlers
		dojo.require("dijit.form.RadioButton");
	},
	"setOptions" : function(options) {
		this.groupName = "egl.dojoRG_" + egl.dojoRadioGroupCount++;
		this.options = options;
		this.inputs = [];
		this.container = egl.createChild(this.eze$$DOMElement, "span");
		for (var n=0; n<this.options.length; n++) {
			var id = this.groupName + "_input_" + n;
			var input = egl.createChild(this.container, "input");
			input.id = id;
			if (!egl.IE) input.setAttribute("type", "radio");
			input.setAttribute("name", this.groupName);
			input.setAttribute("value", this.options[n]);
			this.inputs.push(input);
			if (this.selected == this.options[n])
				input.setAttribute("checked", "checked");
			var label = egl.createChild(this.container, "label");
			label.innerHTML = options[n];
			label.setAttribute("for", id);
			label.style.padding = "3px";
			if (this.vertical)
				egl.createChild(this.container, "br");
		}
		this.container.style.visibility = "hidden";
		this.renderWhenDojoIsDoneLoading();
	},
	"render" : function() {
		var eglWidget = this;
		for (var n=0; n<this.options.length; n++) {
			var radio = new dijit.form.RadioButton({
				id: "egl.dojoRG_" + egl.dojoRadioGroupCount++ + "__" + n,
				checked: (this.selected == this.options[n]),
				name: this.groupName,
				index: n,
				onClick: function() { 
					var input = eglWidget.inputs[this.index];
					eglWidget.selected = input.value;
					eglWidget.handleEvent(eglWidget.getOnChange(), "onChange");
				}
			}, this.inputs[n]);
		}
		this.container.style.visibility = "visible";
	},
	"setSelected" : function(selected) {
		this.selected = selected;
		if (this.container) {
			this.eze$$DOMElement.removeChild(this.container);
			this.setOptions(this.options);
		}
	},
	"getSelected" : function() {
		return this.selected;
	}
});