/*
 * Licensed Materials - Property of IBM
 *
 * Copyright IBM Corporation 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA DP Schedule Contract with IBM Corp.
 */

egl.defineWidget(
	'dojo.widgets', 'DojoTree',
	'dojo.widgets', 'DojoContainer',
	'div',
{
	"constructor" : function() {
		this.setChildType("dojo.widgets.DojoTreeNode");
		dojo.require("dijit.Tree"); 
		dojo.require("dojo.data.ItemFileWriteStore"); 
		this.eglNodes = {};
	},
	"createDojoWidget" : function(parent){
		this.storeData = {
			identifier: 'id',
			label: 'text',
			items: this.getModelData()
		};
		this.store = new dojo.data.ItemFileWriteStore({data: this.storeData});
		var eglWidget = this;
		this.model = new dijit.tree.ForestStoreModel({
			store: this.store,
			rootLabel: this.text
		});
		this.dojoWidget = new dijit.Tree({
			model: this.model,
			onClick: function(item, node) {
				eglWidget.selection = item.id || eglWidget.id;
				eglWidget.handleEvent(eglWidget.getOnClick());
			}
		}, parent);
		setTimeout(egl.startVEWidgetTimer, 2000);
		this.dojoWidget.startup();
	},
	"addChild" : function(child, index) {
		this.checkChildType(child, index);	
		child.setTree(this);
		child.parent = this;
	},
	"getElementById" : function(id) {
		var modelContainsThisItem = null;
		this.store.fetchItemByIdentity({
			identity: id, 
			onItem: function (item) {
				modelContainsThisItem = item;
			}
		});
		if (modelContainsThisItem)
			return this.eglNodes[id];
		return null;
	},
	"setId" : function(id){
		this.id = id;
		this.eze$$DOMElement.id = id;
	},
	"getModelData" : function() {
		var model = []; 
		for (var n=0; n<this.children.length; n++) {
			var child = this.children[n]
            child.setTree(this);
			model.push(child.getItem());
		}
		return model;
	}
});