/*
 * Licensed Materials - Property of IBM
 *
 * Copyright IBM Corporation 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA DP Schedule Contract with IBM Corp.
 */

egl.defineWidget(
	'dojo.widgets', 'DojoDateTextBox',
	'dojo.widgets', 'DojoBase',
	'div',
{
	"constructor" : function() {
		dojo.require("dijit.form.DateTextBox");
	},
	"createDojoWidget" : function(parent){
		var eglWidget = this;
  		var date = new Date();
  		var time = date.getTime();
  		this.dojoWidget = new dijit.form.DateTextBox({
			id : "ddtb" + time, 
			type : "text", 
			required : "true", 
			method : "post",
			invalidMessage : this.message || "Invalid Date", 
			onChange: function() { eglWidget.handleEvent(eglWidget.getOnChange(), "onChange") }, 
			onMouseOver: function() {
				eglWidget.selectionEnabled = egl.egl.ui.rui.RUILib['$inst'].getTextSelectionEnabled();
				egl.egl.ui.rui.RUILib['$inst'].setTextSelectionEnabled(true);
			}, 
			onMouseOut: function() { 
				egl.egl.ui.rui.RUILib['$inst'].setTextSelectionEnabled(eglWidget.selectionEnabled) 
			},
			onClick : function() { eglWidget.dojoWidget._open(); }
		}, parent);
  		this.dojoWidget.constraints.formatLength = this.formatLength || "short";
  		this.dojoWidget.startup();
  		if (this.data) 
  			this.setValue(this.data);
  	},
  	"clear" : function () {
  		if (this.dojoWidget) {
  			this.dojoWidget.setDisplayedValue("");
  		}
	},  	
  	"setValue" : function( date ){
		if (this.dojoWidget) {
			var s = this.dojoWidget.format(date, this.dojoWidget.constraints );
			this.dojoWidget.setDisplayedValue(s);
		}
		else
			this.setData(date);
  	},
  	"getValue" : function(){
  		if (this.dojoWidget) {
  			return this.dojoWidget.value;
  		}
  		else 
  			return this.data
  	},
  	"setErrorMessage" : function ( message ){
  		this.message = message; 
		if (this.dojoWidget)
			this.dojoWidget.constraints.invalidMessage = message;
  	},
  	"getErrorMessage" : function(){
  		return this.message;
  	},
  	"setFormatLength" : function ( format ) {
  		this.formatLength = format;
		if (this.dojoWidget)
			this.dojoWidget.constraints.formatLength = format;
  	},
  	"getFormatLength" : function(){
  		return this.formatLength;
  	}
});