/*
 * Licensed Materials - Property of IBM
 *
 * Copyright IBM Corporation 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA DP Schedule Contract with IBM Corp.
 */

var egl_dojoMenuItemCount = 1;

egl.defineWidget(
	'dojo.widgets', 'DojoMenuItem',
	'dojo.widgets', 'DojoContainer',
	'div',
{
	"constructor" : function() {
		this.setChildType("dojo.widgets.DojoMenu");
		dojo.require("dijit.PopupMenuItem");
		dojo.require("dijit.MenuItem");
	},
	"createDojoWidget" : function(parent) {
		var eglWidget = this;
		this.dojoWidget = this.children && this.children.length 
			? new dijit.PopupMenuItem({ 
				label: this.text, 
				disabled: this.disabled, 
				popup: this.getSubMenu() 
			})
			: this.text
				? new dijit.MenuItem({
					label: this.text,
					id: this.id || "egl.dojoMenuItem" + egl_dojoMenuItemCount++,
					iconClass: this.iconClass || "",
					disabled: this.disabled || false,
					onClick: function() { eglWidget.handleEvent(eglWidget.getOnClick(), "onClick") }
				  })
				: new dijit.MenuSeparator();
	},
	"getSubMenu" : function() {
		var error = {message: "A popup menu requires exactly one child, which has to be of type dojo.widgets.DojoMenu"};
		if (this.children.length == 0)
			this.showError("dojo.widgets.DojoMenu", "DojoMenuItem", null, "getSubMenu", error);
		else
		if (this.children[0].eze$$typename != "DojoMenu")
			this.showError("dojo.widgets.DojoMenu", "DojoMenuItem", this.children[0], "getSubMenu", error);
		return (this.children[0].dojoMenu);
	},
	"setDisabled" : function(disabled) {
		this.disabled = disabled;
		if (this.dojoWidget)
			this.dojoWidget.setDisabled(disabled);
	},
	"getDisabled" : function() {
		return this.disabled;
	}
});