/*
 * Licensed Materials - Property of IBM
 *
 * Copyright IBM Corporation 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA DP Schedule Contract with IBM Corp.
 */

var egl_dojoTabContainerCount = 1;

egl.defineWidget(
	'dojo.widgets', 'DojoTabContainer',
	'dojo.widgets', 'DojoContainer',
	'div',
	{
	"constructor" : function() {
		this.setChildType("dojo.widgets.DojoContentPane");
		this.width = 800;
		this.height = 450;
		dojo.require("dijit.layout.StackContainer");
		dojo.require("dijit.layout.TabContainer");
		dojo.require("dijit.layout.ContentPane");
		this.selectedChild = -1;
	},
	"createDojoWidget" : function(parent) {
		this.dojoID = "egl.DojoTabContainer" + egl_dojoTabContainerCount++;
		this.dojoWidget = new dijit.layout.TabContainer({ 
				tabPosition: this.getDojoTabPosition(), 
				doLayout: true, 
				id: this.dojoID,
				style: "width:"+egl.toPX(this.width)+";height:"+egl.toPX(this.height)
			}, 
			parent
		);
		this.dojoWidget.startup();
		this.addEventHandlers();
		if (this.selectedChild != -1)
			this.setSelection(this.selectedChild);
	},
	"copyStyle" : function(style) {
		//egl.dojo.widgets.DojoBase.prototype.copyStyle.call(this, style);
	},
	"addChild" : function(child, index) {
		if (this.selectedChild)
			child.selected = (index == this.selectedChild);
		egl.dojo.widgets.DojoContainer.prototype.addChild.call(this, child);
	},
	"addEventHandlers" : function() {
		var eglWidget = this;
		dojo.subscribe(this.dojoID+"-selectChild", function(child) {
			if (eglWidget.eze$$ready) {
				eglWidget.selection = eglWidget.getChildIndex(child) + 1;
				eglWidget.notifyListeners(child.eglWidget, eglWidget.getOnTabSelected(), "onTabSelected");
			}
		});
		dojo.subscribe(this.dojoID+"-removeChild", function(child) {
			if (eglWidget.eze$$ready) {
				var index = eglWidget.getChildIndex(child);
				eglWidget.selection = index + 1;
				eglWidget.children.splice(index,1);
				eglWidget.notifyListeners(child.eglWidget, eglWidget.getOnTabRemoved(), "onTabRemoved");
			}
		});
	},
	"notifyListeners" : function(widget, handlers, eventName) {
		for (var n=0; n<handlers.length; n++) {
			try {
				handlers[n]({ widget: widget});
			}
			catch (e) {
				egl.printError("DojoTabContainer: event handler for "+eventName+" failed.", e);
			}
		}
	},
	"getDojoTabPosition" : function() {
		if (this.tabPosition == "top") return "top-h";
		if (this.tabPosition == "bottom") return "bottom-h";
		if (this.tabPosition == "right") return "right-h";
		return "left-h";		
	},
	"getSelection" : function(){
		return this.selection;
	},
	"setSelection" : function(index){
		var eglWidget = this;
		this.selectedChild = index;
		setTimeout(function() {
			if (eglWidget.dojoWidget) {
				var contentPanes = eglWidget.dojoWidget.getChildren();
				if (index > 0 && index <= contentPanes.length) {
					eglWidget.selection = index;
					eglWidget.dojoWidget.selectChild(contentPanes[index-1]);
				}
			}
		},1);
	},
	"getOnTabSelected" : function() { return this.onTabSelected || (this.onTabSelected = []); },
	"getOnTabAdded" : function() { return this.onTabAdded || (this.onTabAdded = []); },
	"getOnTabRemoved" : function() { return this.onTabRemoved || (this.onTabRemoved = []); },
	"setOnTabSelected" : function() { throw egl.egl.ui.rui.Widget.ErrorMessageForEventHandlers; }		
});