/*
 * Licensed Materials - Property of IBM
 *
 * Copyright IBM Corporation 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA DP Schedule Contract with IBM Corp.
 */

egl.defineWidget(
	'dojo.widgets', 'DojoToggleButton',
	'dojo.widgets', 'DojoBase',
	'div',
{
	"constructor" : function() {
		this.text = "";
		this.checkedText = "";
		var eglWidget = this;
		setTimeout(function() {
			eglWidget.renderWhenDojoIsDoneLoading();
		},1);		
		dojo.require("dijit.form.Button");	
	},
	"createDojoWidget" : function(parent) {
		this.runEventHandlers = function() { }; // turn off EGL basic event handlers
		var eglWidget = this;
		this.dojoWidget = new dijit.form.ToggleButton({
            onClick: function() { eglWidget.handleEvent(eglWidget.getOnClick(), "onClick") },
            onChange: function(val) { if (val) { this.attr('label', eglWidget.checkedText); } else { this.attr('label', eglWidget.text); } },
            label: this.text
        },
        parent);
		this.dojoWidget.setDisabled(this.disabled ? true : false);
	},
	"isChecked" : function() {
		if (this.dojoWidget)
			return this.dojoWidget.attr('checked');
	},
	"copyStyle" : function(style) {
		egl.dojo.widgets.DojoBase.prototype.copyStyle.call(this, style);
		if (this.width) egl.setWidth(this.dojoWidget.domNode.firstChild.firstChild, egl.toPX(this.width));
	},
	"setText": function(text) {
		this.text = text;
		if (this.dojoWidget)
			this.dojoWidget.setLabel(text);
	},
	"setCheckedText" : function(text) {
		this.checkedText = text;		
	},
	"setDisabled": function(disabled) {
		this.disabled = disabled;
		if (this.dojoWidget)
			this.dojoWidget.setDisabled(this.disabled ? true : false);
	},
	"getText" : function() {
		return this.text;
	},
	"getCheckedText" : function() {
		return this.checkedText;
	}
});